/*----------------------------------------------------------------------
  File     : DIC.h
  Contents : DIC algorithm for finding frequent sets
  Author   : Bart Goethals
  Creation : 25/5/2004 
  ----------------------------------------------------------------------*/

#include <set>
#include <fstream>
using namespace std;
#include "Data.h"
#include "Item.h"

class DIC 
{
 public:

  DIC();
  ~DIC();

  void setData(char *fn, int type);
  int setOutputSets(char *fn);
  void setMinSup(int ms){minsup=ms;}
  void setInterval(int m){M = m;}
  int generateSets();

 protected:
	
  int generateCandidates();
  int generateCandidates(set<Item> *items, int depth, int *current);
  bool checkSubsets(int sl, int *iset, set<Item> *items, int spos, int depth);

  int countCandidates();

  int processTransaction(Transaction *t, set<Item> *items, int spos);

  void printSet(const Item& item, int *itemset, int length);


 private:

  Item *trie;
  int minsup;
  ofstream setsout;
  Data *data;
  int tnr;
  int M;
  int counting;
  int frequent;
};
