/*----------------------------------------------------------------------
  File     : Item.h
  Contents : itemset management
  Author   : Bart Goethals
  Update   : 4/4/2003 
  ----------------------------------------------------------------------*/

#include <set>
using namespace std;

class Item
{
 public:

  Item(int i, int t=0) : id(i), support(0), children(0), flag('a'), start(t) {}
  Item(const Item &i) : id(i.id), support(i.support), children(i.children), flag(i.flag), start(i.start) {}
  ~Item(){}

  int getId() const {return id;}
  bool Counting() const {return ((flag=='a') || (flag=='b'));}
  bool Frequent() const {return ((flag=='b') || (flag=='d'));}
  void setFlag(char c) const {flag = c;}
  int getStart() const {return start;}

  int Increment(int inc = 1) const {return support+=inc;}

  set<Item> *makeChildren() const;
  set<Item> *getChildren() const {return children;}
  int deleteChildren() const;

  int getSupport() const {return support;}

  bool operator<(const Item &i) const{return id < i.id;}

 private:

  const int id;

  mutable int support;
  mutable set<Item> *children;
  mutable char flag; 
  // 'a' means infrequent and counting
  // 'b' means frequent and counting
  // 'c' means infrequent and counted
  // 'd' means frequent and counted
  mutable int start;
};
