/*----------------------------------------------------------------------
  File     : dictest.cpp
  Contents : DIC algorithm for finding frequent sets
  Author   : Bart Goethals
  Update   : 25/5/2004
----------------------------------------------------------------------*/

#include "DIC.h"
#include <iostream>
#include <time.h>

int main(int argc, char *argv[])
{
  cout << "DIC frequent itemset mining implementation" << endl;
  cout << "by Bart Goethals, 2004" << endl;
  cout << "http://www.cs.helsinki.fi/u/goethals/" << endl << endl;
  
  if(argc < 5) {
    cerr << "usage: " << argv[0] << " datafile datatype minsup interval [output]" << endl;
    cerr << "datatype = 1 for Quest datagenerator binary" << endl;
    cerr << "datatype = 2 for Quest datagenerator ascii" << endl;
    cerr << "datatype = 3 for flat, i.e. all items per transaction on a single line" << endl;
    cerr << "datatype = 4 for ascii version of Quest datagenerator binary" << endl;
  }
  else {
    DIC a;
    a.setData(argv[1],atoi(argv[2]));
    a.setMinSup(atoi(argv[3]));
    a.setInterval(atoi(argv[4]));
    if(argc==6) a.setOutputSets(argv[5]);
    
    clock_t start = clock();
    int sets = a.generateSets();
    cout << sets << "\t[" << (clock()-start)/double(CLOCKS_PER_SEC) << "s]" << endl;
    if(argc==6) cout << "Frequent sets written to " << argv[5] << endl;
  }

  return 0;
}

